/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package XMLSchema.schemavalidation;


import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import java.util.logging.Level;
import java.util.logging.Logger;

import javax.xml.XMLConstants;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.stream.StreamSource;

import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;

import org.w3c.dom.Document;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 *
 * @author bar
 */
public class SchemaValidator {
    private Schema schema;
    private Document doc;

    public SchemaValidator(String fileName,String schemaName){
        try {
            SchemaFactory schf = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
            schema = schf.newSchema(new File(schemaName));

            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            dbf.setSchema(schema);
            DocumentBuilder docBuilder = dbf.newDocumentBuilder();
            
            Validator validator = schema.newValidator();
            validator.validate(new StreamSource(new FileInputStream(fileName)));
            System.out.println("Document is valid");
        } catch (IOException ex) {
            Logger.getLogger(SchemaValidator.class.getName()).log(Level.SEVERE, null, ex);
            throw new IllegalArgumentException("Nelze nacist soubor",ex);
        } catch (ParserConfigurationException ex) {
            Logger.getLogger(SchemaValidator.class.getName()).log(Level.SEVERE, null, ex);
            throw new IllegalArgumentException("Chyba konfigurace parseru",ex);
        } catch (SAXException ex) {
            //Logger.getLogger(SchemaValidator.class.getName()).log(Level.SEVERE, null, ex);
            System.out.println("Document is not valid: " + ex.getMessage());
        }
    }

    public static void main(String[] args){
        if(args.length<2){
            System.err.println("Program ma 2 parametry <schema> <xml soubor>.");
            System.exit(-1);
        }
        SchemaValidator validator = new SchemaValidator(args[1], args[0]);
    }

}
