/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package xpath;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author bar
 */
public class Evaluator {
    private String fileName = null;
    private Document doc;

    public Evaluator(String fileName){
        this.fileName = fileName;
        loadDocument();
    }

    private void loadDocument() {
        try {
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();
            doc = db.parse(new FileInputStream(fileName));
        } catch (SAXException ex) {
            Logger.getLogger(Evaluator.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Evaluator.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ParserConfigurationException ex) {
            Logger.getLogger(Evaluator.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public NodeList evaluate(String xPath) throws XPathExpressionException{
        try {
            XPathFactory xpf = XPathFactory.newInstance();
            XPath xp = xpf.newXPath();
            return (NodeList) xp.evaluate(xPath, doc.getDocumentElement(), XPathConstants.NODESET);
        } catch (XPathExpressionException ex) {
            Logger.getLogger(Evaluator.class.getName()).log(Level.SEVERE, "Chyba vyhodnocovani xpath vyrazu: ", ex);
            throw ex;
        }
    }

    public void displayResult(NodeList nodes){
        Element root = doc.createElement("result");
        try {
            TransformerFactory tf = TransformerFactory.newInstance();
            Transformer trace = tf.newTransformer();
            for(int i=0 ; i<nodes.getLength() ; i++){
                root.appendChild(nodes.item(i));
            }
            trace.transform(new DOMSource(root), new StreamResult(System.out));
        }catch(TransformerException ex){
            Logger.getLogger(Evaluator.class.getName()).log(Level.SEVERE, "Chyba transformace: ", ex);
        }

    }

    public static void main(String[] args) throws XPathExpressionException{
        if(args.length <2){
            System.err.println("Malo parametru.");
            System.exit(-1);
        }
        Evaluator eval = new Evaluator(args[1]);
        eval.displayResult(eval.evaluate(args[0]));
    }
}
